from PyQt5 import QtWidgets,QtCore,QtGui

from PyQt5.QtCore import *
from PyQt5.QtWidgets import *
from PyQt5.QtGui import *

class GraphWindowDelegate(QStyledItemDelegate):
    """Item delegate to remove the .pickle from filenames in each sheet directory"""

    def initStyleOption(self, option, index):
        """Initializes the styled item."""
        super().initStyleOption(option, index)
        if isinstance(index.model(), QFileSystemModel):
            if not index.model().isDir(index):
                option.text = index.model().fileInfo(index).baseName()

    def setEditorData(self, editor, index):
        """Sets the graph icon and text for the item."""
        if isinstance(index.model(), QFileSystemModel):
            if not index.model().isDir(index):
                graph_icon = QtGui.QPixmap("graph_icon.png")
                editor.setIcon(QtGui.QIcon(graph_icon))
                editor.setText(index.model().fileInfo(index).baseName())
            else:
                super().setEditorData(editor, index)

    def setModelData(self, editor, model, index):
        """Sets the data item in the file system model."""
        if isinstance(model, QFileSystemModel):
            fi = model.fileInfo(index)
            if not model.isDir(index):
                model.setData(index, editor.text() + "." + fi.suffix())
            else:
                super().setModelData(editor, model.index)

