import pandas as pd
import os


def get_col_names(df):
    """
    Gets and prints all of the column names in a DataFrame.
    """
    for col in df.columns:
        print(col)


def get_sheet_names(dictionary):
    """
    Gets and prints all of the sheet names in a dictionary of DataFrames.
    """
    for key in dictionary.keys():
        print(key)


def get_extension(import_file_path):
    """
    Splits up the given filepath into the filename and file extension.
    :return: The file's extension
    """
    return os.path.splitext(import_file_path)[1] 


def get_filename(import_file_path):
    """
    Splits up the given filepath into the filename and file extension.
    :return: The file's filename (basename)
    """
    base = os.path.basename(import_file_path)
    return os.path.splitext(base)[0]


def clean_cols_without_name(df):
    """
    Removes any columns in the given DataFrame that are unamed.
    :return: A DataFrame with only named columns
    """
    return df[df.filter(regex='^(?!Unnamed)').columns]

