import pandas
from plotly import graph_objects as go
import plotly.express as px

from GraphKey.app.modules.graphing.figure.figure import Figure


class BoxPlot(Figure):
    """
    This is the specific sub-class to generate box plots.
    """
    def __init__(self, df: pandas.DataFrame):
        super().__init__(df)
        self._df = df
        self._figure = None

    def construct_figure(self, config: dict):
        self._figure = px.box(self._df, **config)

    def get_figure(self) -> go.Figure:
        return self._figure
