
# TODO For all graph types, make sure to set symbol and color, so that the symbol and color theme the user selects actually applies

# import tkinter
# from tkinter import filedialog 
import pandas as pd
import plotly.graph_objects as go
import plotly.express as px
from PyQt5.QtCore import QUrl
import math

import sys, os
from GraphKey.app.modules.data_import.import_file import DataImport
import pathlib


from GraphKey.app.modules.graphing.figure.figure_factory import FigureFactory, SupportedFigures
from GraphKey.app.modules.graphing.figure.graphing_utils import delete_empty_rows


# TODO: Finish implementation of dot plot
def dot(df):
    # Select file for a dot plot. Use data_for_import_file_and_create_graph.xlsx
    # df = pd.read_excel(filepath)
    # Get data into arrays
    DHMA = df["Sample D DHMA (ug/G)"]
    LDOPA = df["Sample D L-DOPA (ug/G)"]
    NOREP = df["Sample D Norepinephrine (ug/G)"]

    # Get the selected columns into arrays
    columns = []
    for x in df.columns[3:]:
        columns.append(x)
    numCol = len(columns)

    # Make a new DataFrame for the dot plot
    newDict = {
        "Chemical Type": columns * 5,
        "Nerochemical Levels (ug/G)": DHMA + LDOPA + NOREP}
    plotDataFrame = pd.DataFrame(newDict)

    # Create and show plot
    # fig = px.scatter(plotDataFrame, x="Nerochemical Levels (ug/G)", y="Chemical Type", title="Test Dot Plot")

    # Get saved configs
    color_configs = pickle.load(open("../settings/save_color_configs.p", "rb"))

    config = {"x": "Nerochemical Levels (ug/G)",
              "y": "Chemical Type",
              "color_discrete_sequence": color_configs["current_theme"]["colors"],
              "title": "Test Dot Plot"}

    dot_plot = FigureFactory.factory(plotDataFrame, SupportedFigures.Dot)
    dot_plot.construct_figure(config)
    return dot_plot.get_figure()


def scatter(df, x_axis, y_axis, color_selected, size_selected):
    # Determine what kind of scatter plot to make
    fig = None
    scatter_df = df
    color_configs = pickle.load(open("../settings/save_color_configs.p", "rb"))

    config = {
        'x': x_axis,
        'y': y_axis,
        'color': color_selected,
        'color_discrete_sequence': color_configs["current_theme"]["colors"], 
        'size': size_selected
    }

    if size_selected != 'None':
        scatter_df = delete_empty_rows(scatter_df, size_selected)

    scatter_plot = FigureFactory.factory(scatter_df, SupportedFigures.Scatter)
    scatter_plot.construct_figure(config)
    return scatter_plot.get_figure()

    # if colorSelected == "None":
    #     if sizeSelected == "None":
    #         fig = px.scatter(df, x=xAxis, y=yAxis)
    #     else:
    #         try:
    #             fig = px.scatter(delete_empty_rows(df, sizeSelected), x=xAxis, y=yAxis, size=sizeSelected)
    #         except Exception as e:
    #             return str(e)
    # else:
    #     if sizeSelected == "None":
    #         fig = px.scatter(df, x=xAxis, y=yAxis, color=colorSelected)
    #     else:
    #         try:
    #             fig = px.scatter(delete_empty_rows(df, sizeSelected), x=xAxis, y=yAxis, color=colorSelected,
    #                              size=sizeSelected)
    #         except Exception as e:
    #             return str(e)
    #
    # return fig


def box(df, column_selected, group_by_selected, enable_group_by, show_all_points):
    # Determine if grouping is enabled
    fig = None
    color_configs = pickle.load(open("../settings/save_color_configs.p", "rb"))
    box_plot = FigureFactory.factory(df, SupportedFigures.Box)
    config = dict()

    config['y'] = column_selected
    if enable_group_by:
        config['x'] = group_by_selected
    if show_all_points:
        config['points'] = "all"
    config['color_discrete_sequence'] = color_configs["current_theme"]["colors"]

    box_plot.construct_figure(config)
    return box_plot.get_figure()

    # if enableGroupBy:
    #     if showAllPoints:
    #         fig = px.box(df, x=groupBySelected, y=columnSelected, points="all")
    #     else:
    #         fig = px.box(df, x=groupBySelected, y=columnSelected)
    # else:
    #     if showAllPoints:
    #         fig = px.box(df, y=columnSelected, points="all")
    #     else:
    #         fig = px.box(df, y=columnSelected)
    #
    # return fig
