import math
import pathlib

from PyQt5.QtCore import QUrl


def delete_empty_rows(df, sizeSelected):
    """
    Loop through the rows in the dataframe,
    if the value for the sizeSelected number doesn't exist, drop the row
    """
    nanRows = []
    i = 0
    for index, row in df.iterrows():
        if math.isnan(row[sizeSelected]):
            nanRows.append(i)
        i += 1

    for r in nanRows:
        df.drop(df.index[r], inplace=True)

    return df


def write_to_html(fig):
    """
    Writes the figure to an HTML file
    :param fig: A Plotly figure object
    :return: An HTML view of the graph
    """
    file = pathlib.Path(__file__)
    # TODO: FIX HOW WE NAVIGATE THE FOLDERS
    data_folder_path = file.parent.parent.parent / "Data" / "CurrentFigure.html"
    data_folder_path_str = str(data_folder_path)

    fig.write_html(data_folder_path_str)
    return QUrl.fromLocalFile(data_folder_path_str)
