import pandas
from plotly import graph_objects as go
import plotly.express as px
import pickle

from GraphKey.app.modules.graphing.figure.figure import Figure


class ScatterPlot(Figure):
    """
    This is the specific sub-class to generate scatter plots.
    """
    def __init__(self, df: pandas.DataFrame):
        super().__init__(df)
        self._df = df
        self._figure = None

    def construct_figure(self, config: dict):
        self._figure = px.scatter(self._df, **config)

    def get_figure(self) -> go.Figure:
        return self._figure
